local leadWire = ...

--------------------------------------------------------------------------
local LEAD_WIRE_COMP = {
	TypeName = _PrefixAsset .. "_LEAD_WIRE_COMP",
	ParentType = "COMPONENT",
	Properties = {
                { Name = "LeadWire_IsSet", Type = "boolean", Default = false },
 	}
}

--------------------------------------------------------------------------
function LEAD_WIRE_COMP:create()
end

--------------------------------------------------------------------------
function LEAD_WIRE_COMP:init()
    self.LeadWire_IsSet = true
    leadWire:log("LeadWire_IsSet = " .. tostring(self.LeadWire_IsSet) .. " y = " .. self:getOwner():getGlobalPosition()[2])
    self:setChildsElevation()
end

function setChildElevation(_decoration)
   if _decoration == nil then
       leadWire:log("_decoration nil")
       return
   end
   if _decoration:getComponent(_PrefixAsset .. "_DECORATION_COMP") == nil then
--       leadWire:log("Component nil")
       return
   end
   leadWire:log("setChildElevation begin")
   if _decoration:getComponent(_PrefixAsset .. "_DECORATION_COMP").majPosition == nil then
       leadWire:log("majPosition not defined")
       return
   end
   _decoration:getComponent(_PrefixAsset .. "_DECORATION_COMP"):majPosition()
   leadWire:log("setChildElevation end")
end

function LEAD_WIRE_COMP:setChildsElevation()
        leadWire:log("LEAD_WIRE_COMP:setChildsElevation begin")
        local _currentObject = self:getOwner() 
        for i=0,20, 1 do
            local _parent = _currentObject:getParent()
            if _parent == nil then    
                leadWire:log("parent nil")
                return
            end
            if _parent.Name == _PrefixAsset .. "_MONUMENT_NAME" then    
                leadWire:log("call forEachChildRecursive")
                _parent:forEachChildRecursive(setChildElevation)
                break
            end
            _currentObject = _parent
        end
        leadWire:log("setChildsElevation end")
end

-------------------------------------
function LEAD_WIRE_COMP:update()
end

--------------------------------------------------------------------------
leadWire:registerClass(LEAD_WIRE_COMP)
